

##
## Print some info
##
PrintAutGroupInfo := function( dim )
    local G, A, M, f, n, i, k, K, l;
    if dim = 2 then n := 17; elif dim = 3 then n := 230; fi;

    for i in [1..n] do
        G := CrystGroupAsPcpGroupIT(dim, i);
        A := AutGroupCrystPcpGroup(G);
        M := AutGroupInducedAction(A);
        if Size(M) < 500 then k := IdGroup(M); else k := Size(M); fi;
        f := IsPolycyclicMatGroup(M);
        Print(i," yields Z^",Length(A!.deriv)," by ",k);

        if f = true then
            i := IsomorphismPcpGroupAutGrpCG(A);
            K := Range(i);
            l := Length(ComplementClasses(K, K!.module));
            if l > 0 then
                Print( " ---- polycyclic and split  \n");
            else
                Print( " ---- polycyclic and non-split \n");
            fi;
        else
            Print("\n");
        fi;
    od;

end;

SortAutGroupInfoDim3 := function( )
    local a, G, A, M, K, h, r, j, i;

    a := [];
    for i in [16..230] do

        # init
        Print("start ",i," \n");
        G := CrystGroupAsPcpGroupIT(3, i);
        A := AutGroupCrystPcpGroup(G);
        M := AutGroupInducedAction(A);
        K := Range(IsomorphismPcpGroupAutGrpCG(A));
        h := Length(ComplementClasses(K, K!.module));

        # first step
        r := [StructureDescription(G/FittingSubgroup(G))];
        Add(r, Length(A!.deriv));
        Add(r, StructureDescription(M));
        if h > 0 then 
            Add(r, "yes");
        else
            Add(r, "no");
        fi;

        # next step
        j := Position( List(a, x -> x{[1..4]}), r);
        if IsBool(j) then 
            Add( r, [i] );
            Add(a, r);
        else
            Add(a[j][5], i);
        fi;
    od;
    return a;
end;


RTInfo := function(dim)
    local n, t, i, G, s, A;
    if dim = 2 then n := 17; elif dim = 3 then n := 230; fi;
    t := [];
    for i in [1..n] do
        Print("start ",i," \n");
        G := CrystGroupAsPcpGroupIT(dim, i);
        s := Runtime();
        A := AutGroupCrystPcpGroup(G);
        s := Runtime() - s;
        Add(t, s);
    od;
    return t;
end;

